//  Теоретический вопрос

// 1. Опишите своими словами как работает цикл forEach.

//  Задание

// Реализовать функцию фильтра массива по указанному типу данных. Задача должна быть реализована на языке javascript,
// без использования фреймворков и сторонник библиотек (типа Jquery).

//  Технические требования:
// - Написать функцию `filterBy()`, которая будет принимать в себя 2 аргумента. Первый аргумент - массив, который будет содержать в
// себе любые данные, второй аргумент - тип данных.
// - Функция должна вернуть новый массив, который будет содержать в себе все данные, которые были переданы в аргумент, за исключением тех,
// тип которых был передан вторым аргументом. То есть, если передать массив ['hello', 'world', 23, '23', null], и вторым аргументом передать
// 'string', то функция вернет массив [23, null].

//  Литература:
// - [Массивы с числовыми индексами](http://learn.javascript.ru/array)
// - [Массив: перебирающие методы](http://learn.javascript.ru/array-iteration)
// - [Шесть типов данных, typeof](https://learn.javascript.ru/types-intro)


function filterBy(array, type) {
    return newArray = array.filter(function (item) {
        if (item === null && type === 'null') {
            return false
        }
        return (typeof item !== type)
    })
}
const array = ['hello', 'world', 23, '23', null];
console.log(filterBy(array, 'string'));

